This OpenCV 4.5.4 library was compiled by x86_64-w64-mingw32-gcc 11.2.0 on Cygwin 3.1.6.
You can reproduce this library by following the steps below.
Before starting, make sure you have FFmpeg installed.

1. Download OpenCV source and checkout the desired branch (4.5.4)

git clone https://github.com/opencv/opencv.git
cd opencv && git checkout 4.5.4

2. Replace "avresample" with "swresample" because newer versions of FFmpeg use "swresample"
   If 'make' fails, you may need to reset the environment variables and backtrack to this step

grep -r -l avresample . | xargs sed -i 's/avresample/swresample/g'

3. Create a build directory

cd .. && mkdir build && cd build

4. Setup the environment. Remember to replace <FFmpeg Directory> and <SmartHLS Directory>

export FFMPEG_PATH=<FFmpeg Directory>
export LEGUP_ROOT_DIR=<SmartHLS Directory>

export PATH=$LEGUP_ROOT_DIR/dependencies/gcc/bin:$PATH
export LD_LIBRARY_PATH=$FFMPEG_PATH/lib:$LEGUP_ROOT_DIR/dependencies/gcc/lib:$LD_LIBRARY_PATH
export PKG_CONFIG_LIBDIR=$FFMPEG_PATH/lib/pkgconfig
export C_INLCUDE_PATH=$FFMPEG_PATH/include:$C_INCLUDE_PATH
export CPLUS_INCLUDE_PATH=$FFMPEG_PATH/include:$CPLUS_INCLUDE_PATH

5. Copy libatomic.so from /usr/lib of a RISC-V Linux distribution to $FFMPEG_PATH/lib
   The libatomic.so included came from Icicle Kit GNU/Linux 5.6.16

6. Configure

cmake \
	-D CMAKE_TOOLCHAIN_FILE=../opencv/platforms/linux/gnu.toolchain.cmake \
	-D BUILD_ZLIB=OFF \
	-D BUILD_ITT=OFF \
	-D BUILD_opencv_python2=OFF \
	-D BUILD_opencv_python3=OFF \
	-D WITH_V4L=OFF \
	-D CMAKE_EXE_LINKER_FLAGS=-Wl,-rpath-link,$FFMPEG_PATH/lib \
	-D BUILD_opencv_nonfree=OFF \
	-D WITH_FFMPEG=ON \
	-D OPENCV_ENABLE_PKG=1 \
	-D OPENCV_GENERATE_PKGCONFIG=ON \
	-D WITH_GTK=OFF -D WITH_OPENCL=OFF \
	-D WITH_1394=0 \
	-D OPENCV_ENABLE_PKG=1 \
	-D BUILD_opencv_gapi=OFF \
	-D WITH_ADE=OFF \
	-D WITH_IPP=OFF \
	-D OPENCV_ENABLE_MEMALIGN=ON \
	-D BUILD_SHARED_LIBS=ON \
	-D OPENCV_DISABLE_THREAD_SUPPORT=ON \
	-D BUILD_LIST=core,videoio,imgcodecs,imgproc \
	-D ENABLE_PIC=ON \
	-D CMAKE_CXX_EXTENSIONS=ON \
	-D OPENCV_FFMPEG_SKIP_BUILD_CHECK=ON \
	-B ./install -S ../opencv

7. Compile and install OpenCV

make && make install

8. OpenCV is now installed somewhere in the "build" folder. Feel free to move and rename OpenCV to a desired location.
